eslint-plugin-vue-scoped-css

ESLint plugin for Scoped CSS in Vue.js

Stats

StarsIssuesVersionUpdatedCreatedSize
eslint-plugin-vue-scoped-css
4561.3.0a month ago2 years agoMinified + gzip package size for eslint-plugin-vue-scoped-css in KB

Readme

eslint-plugin-vue-scoped-css

eslint-plugin-vue-scoped-css is ESLint plugin for Scoped CSS in Vue.js.

NPM license NPM version NPM downloads NPM downloads NPM downloads NPM downloads NPM downloads Build Status Coverage Status

Features

This ESLint plugin provides linting rules relate to better ways to help you avoid problems when using Scoped CSS in Vue.js.

  • Provides linting rules for Scoped CSS.
  • Supports CSS syntax including level 4 selectors.
  • Supports <style lang="scss">.
  • Supports <style lang="stylus">.
  • Parses <style>, <template> and <script> blocks.

You can check on the Online DEMO.

Documentation

See documents.

Installation

npm install --save-dev eslint eslint-plugin-vue-scoped-css

Requirements

  • ESLint v5.0.0 and above
  • Node.js v8.10.0 and above

Usage

Create .eslintrc.* file to configure rules. See also: http://eslint.org/docs/user-guide/configuring.

Example .eslintrc.js:

module.exports = {
  extends: [
    // add more generic rulesets here, such as:
    // 'eslint:recommended',
    'plugin:vue-scoped-css/vue3-recommended'
  ],
  rules: {
    // override/add rules settings here, such as:
    // 'vue-scoped-css/no-unused-selector': 'error'
  }
}

Configs

This plugin provides some predefined configs:

  • plugin:vue-scoped-css/base - Settings and rules to enable this plugin
  • plugin:vue-scoped-css/recommended - /base, plus rules for better ways to help you avoid problems for Vue.js 2.x
  • plugin:vue-scoped-css/vue3-recommended - /base, plus rules for better ways to help you avoid problems for Vue.js 3.x
  • plugin:vue-scoped-css/all - All rules of this plugin are included

Rules

The --fix option on the command line automatically fixes problems reported by rules which have a wrench :wrench: below.

Recommended for Vue.js 3.x

Enforce all the rules in this category with:

{
  "extends": "plugin:vue-scoped-css/vue3-recommended"
}
Rule ID Description
vue-scoped-css/no-deprecated-deep-combinator disallow using deprecated deep combinators :wrench:
vue-scoped-css/no-parent-of-v-global disallow parent selector for ::v-global pseudo-element
vue-scoped-css/no-parsing-error disallow parsing errors in <style>
vue-scoped-css/no-unused-keyframes disallow @keyframes which don't use in Scoped CSS
vue-scoped-css/no-unused-selector disallow selectors defined in Scoped CSS that don't use in <template>
vue-scoped-css/require-v-deep-argument require selector argument to be passed to ::v-deep() :wrench:
vue-scoped-css/require-v-global-argument require selector argument to be passed to ::v-global()
vue-scoped-css/require-v-slotted-argument require selector argument to be passed to ::v-slotted()

Recommended for Vue.js 2.x

Enforce all the rules in this category with:

{
  "extends": "plugin:vue-scoped-css/recommended"
}
Rule ID Description
vue-scoped-css/no-parsing-error disallow parsing errors in <style>
vue-scoped-css/no-unused-keyframes disallow @keyframes which don't use in Scoped CSS
vue-scoped-css/no-unused-selector disallow selectors defined in Scoped CSS that don't use in <template>

Uncategorized

No preset enables the rules in this category. Please enable each rule if you want.

For example:

{
  "rules": {
    "vue-scoped-css/enforce-style-type": "error"
  }
}
Rule ID Description
vue-scoped-css/enforce-style-type enforce the <style> tags to be plain or have the scoped or module attribute
vue-scoped-css/no-deprecated-v-enter-v-leave-class disallow v-enter and v-leave classes.
vue-scoped-css/require-selector-used-inside disallow selectors defined that is not used inside <template>

Deprecated

  • :warning: We're going to remove deprecated rules in the next major release. Please migrate to successor/new rules.
  • :innocent: We don't fix bugs which are in deprecated rules since we don't have enough resources.
Rule ID Replaced by
vue-scoped-css/require-scoped vue-scoped-css/enforce-style-type

Contributing

Welcome contributing!

Please use GitHub's Issues/PRs.

Development Tools

  • npm test runs tests and measures coverage.
  • npm run update runs in order to update readme and recommended configuration.

License

See the LICENSE file for license rights and limitations (MIT).

If you find any bugs or have a feature request, please open an issue on github!

The npm package download data comes from npm's download counts api and package details come from npms.io.